#include "talkd.h"

#ifndef MAXLOGNAME
#define MAXLOGNAME 12
#endif

typedef struct _ctlchar {
                char            kill;
                char            cerase;
                char            werase;
} edit_chars;

typedef struct _TalkSession {
                int             sockt;
                CTL_MSG        	msg;
                char            *this_line;
                int             usable;
                int             invitation_waiting;
		int		timer_refnum;
		int		closed;
        struct  _TalkSession *  next;
		char *		user_ref;
		char		*status;

                u_short         daemon_port;    /* port number of the talk daemon */
        struct  sockaddr_in     daemon_addr;

                int             ctl_sockt;
        struct  sockaddr_in     ctl_addr;
        struct  sockaddr_in     my_addr;


                char            local_user [MAXLOGNAME];
                char            local_host [MAXHOSTNAMELEN];
        struct  in_addr         local_addr;
                edit_chars      local_edit;
		long		local_id;

                char            remote_user [MAXLOGNAME];
                char            remote_host [MAXHOSTNAMELEN];
        struct  in_addr         remote_addr;
                char		remote_tty  [TTY_SIZE];
                edit_chars      remote_edit;
		long		remote_id;
} TalkSession;


int do_talk (char *remote_peer);
void set_talk_bits (fd_set *rd);
int check_talks(fd_set *read_set);
int write_to_talk (char *userhost, char *line);
void talkcmd (char *, char *, char *);
